//*****************************************************************************
//*
//*
//*		RemoveDebugFromLib.cpp
//*
//*
//*****************************************************************************
//
//		Entfernt Debug-Informationen aus Bibliotheken
//
//		Syntax:		[-m] [-o out_path] in_path
//
//					-m		= Messagebox anzeigen
//					-o		= Zieldatei
//
#include	"StdAfx.h"
#include	"RemoveDebugFromLib.h"
#include	"RemoveDebugFromLibDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CRemoveDebugFromLibApp, CWinApp)
	//{{AFX_MSG_MAP(CRemoveDebugFromLibApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

// Das einzige CRemoveDebugFromLibApp-Objekt
CRemoveDebugFromLibApp theApp;

int LibRemoveDebug(const char *pLibName,const char *pNewName);

//*****************************************************************************
//*
//*		CRemoveDebugFromLibApp
//*
//*****************************************************************************
//  CRemoveDebugFromLibApp Konstruktion
CRemoveDebugFromLibApp::CRemoveDebugFromLibApp()
{
}


//*****************************************************************************
//*
//*		InitInstance
//*
//*****************************************************************************
//  CRemoveDebugFromLibApp Initialisierung
BOOL CRemoveDebugFromLibApp::InitInstance()
{
LPCTSTR		pLibOut;
LPCTSTR		pLibIn;
LPCTSTR		pParam;
CString		sText;
int			iMsg;
int			iPos;
int			iRet;

	
	pLibOut = NULL;
	pLibIn  = NULL;
	iMsg	= 0;

	for(iPos=1;iPos<__argc;iPos++)							// Parameter auswerten
		{
		pParam = __argv[iPos];

		if(pParam[0]=='-' || pParam[0]=='/')
			{
			if(pParam[1]=='M' || pParam[1]=='m')
				{
				iMsg=1;
				continue;
				}
			
			if(pParam[1]=='O' || pParam[1]=='o')
				{
				if(iPos+1<__argc)
					{
					iPos++;				
					pLibOut=__argv[iPos];
					}
				continue;
				}
			
			continue;
			}

		pLibIn = pParam;
		}


//*****************************************************************************


	if(pLibIn)
		{
		if(ExistFile(pLibIn)!=1)
			{
			if(iMsg)MessageBox(0,"Die Datei konnte nicht gefunden werden !","Fehler",MB_OK|MB_ICONERROR);
			return FALSE;
			}
	
		iRet = LibRemoveDebug(pLibIn,NULL);

		if(iRet==-1)
			{
			if(iMsg)MessageBox(0,"Die Datei konnte nicht geffnet werden !","Fehler",MB_OK|MB_ICONERROR);
			return FALSE;
			}

		if(iRet==-2)
			{
			if(iMsg)MessageBox(0,"Es wurden keine Debug-Informationen in der Bibliothek gefunden !","Fehler",MB_OK|MB_ICONERROR);
			return FALSE;
			}

		if(iRet)
			{
			sText.Format("Es gab einen Fehler beim Laden (%i) !",iRet);
			if(iMsg)MessageBox(0,sText,"Fehler",MB_OK|MB_ICONERROR);
			return FALSE;
			}

		if(iMsg)MessageBox(0,"Es wurde eine Bibliothek ohne Debug-Informationen erstellt.","Information",MB_OK|MB_ICONINFORMATION);
		
		return FALSE;
		}


	
//*****************************************************************************

	
	AfxUtilityInit();
	AfxEnableControlContainer();


	#ifdef		_AFXDLL 				
	Enable3dControls(); 										// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
	#else
	Enable3dControlsStatic();									// Diese Funktion bei statischen MFC-Anbindungen aufrufen
	#endif

	CRemoveDebugFromLibDlg sDlg;
	
	m_pMainWnd = &sDlg;
	sDlg.DoModal();


return FALSE;
}
