//*****************************************************************************
//*
//*
//*		RemoveDebugFromLibDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"RemoveDebugFromLib.h"
#include	"RemoveDebugFromLibDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CRemoveDebugFromLibDlg, CDialog)
	//{{AFX_MSG_MAP(CRemoveDebugFromLibDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnPath)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


int LibRemoveDebug(const char *pLibName,const char *pNewName);


//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  CRemoveDebugFromLibDlg Dialogfeld
CRemoveDebugFromLibDlg::CRemoveDebugFromLibDlg(CWnd *pParent): CDialog(CRemoveDebugFromLibDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CRemoveDebugFromLibDlg)
	m_sLibPath = _T("");
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CRemoveDebugFromLibDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRemoveDebugFromLibDlg)
	DDX_CBString(pDX, IDC_COMBO1, m_sLibPath);
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  CRemoveDebugFromLibDlg Nachrichten-Handler
BOOL CRemoveDebugFromLibDlg::OnInitDialog()
{
CMenu *pSysMenu;


	SubclassComboBox (this,IDC_COMBO1,SCB_DROPFILE);
	SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);
	ComboBoxLoad(this,IDC_COMBO1,"#NameList","Software\\AZ\\RemoveDebugFromLib",m_sLibPath);


	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT((IDM_ABOUTBOX < 0xF000));

	pSysMenu = GetSystemMenu(FALSE);

	if(pSysMenu!=NULL)
		{
		CString	sAboutMenu;


		sAboutMenu.LoadString(IDS_ABOUTBOX);
		if(!sAboutMenu.IsEmpty())
			{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, sAboutMenu);
			}
		}

	SetIcon(m_hIcon,TRUE); 										// Groes Symbol verwenden
	SetIcon(m_hIcon,FALSE);										// Kleines Symbol verwenden


return TRUE; 
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CRemoveDebugFromLibDlg::OnDestroy() 
{

	DelButtonBitmap(this,IDC_BUTTON1);

	CDialog::OnDestroy();
	
}

//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CRemoveDebugFromLibDlg::OnSysCommand(UINT nID,LPARAM lParam)
{
	if((nID&0xFFF0) == IDM_ABOUTBOX)
		{
		CDialog	sDlg(IDD_ABOUTBOX);

		sDlg.DoModal();
		}
	else{
		CDialog::OnSysCommand(nID,lParam);
		}
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
//  Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
// 	den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
// 	Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CRemoveDebugFromLibDlg::OnPaint()
{
int		iIconX;
int		iIconY;
int		iPosX;
int		iPosY;

	if(IsIconic())
		{
		CPaintDC sDc(this);										// Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM)sDc.GetSafeHdc(),0);

		iIconX = GetSystemMetrics(SM_CXICON);					// Symbol in Client-Rechteck zentrieren
		iIconY = GetSystemMetrics(SM_CYICON);
		
		CRect sRect;
		
		GetClientRect(&sRect);
		
		iPosX = (sRect.Width ()-iIconX+1)/2;
		iPosY = (sRect.Height()-iIconY+1)/2;

		// Symbol zeichnen
		sDc.DrawIcon(iPosX,iPosY,m_hIcon);
		}
	else{
		CDialog::OnPaint();
		}
}

//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
//  Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
// 	das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CRemoveDebugFromLibDlg::OnQueryDragIcon()
{

return (HCURSOR)m_hIcon;
}

//*****************************************************************************
//*
//*		OnPath
//*
//*****************************************************************************
void CRemoveDebugFromLibDlg::OnPath()
{
CString	sPath;



	UpdateData();

	sPath=m_sLibPath;
	if(sPath=="")sPath="*.lib";
	
	CFileDialog	sFile(FALSE,"*.lib",sPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,"Programm-Dateien ( *.lib )|*.lib|Alle Dateien|*.*|");

	   sFile.m_ofn.lpstrTitle="Datei auswhlen";
	if(sFile.DoModal()!=IDOK)return;

	m_sLibPath = sFile.GetPathName();					// Pfad speichern

	UpdateData(FALSE);

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CRemoveDebugFromLibDlg::OnCancel()
{

	UpdateData();
	ComboBoxSave(this,IDC_COMBO1,"#NameList","Software\\AZ\\RemoveDebugFromLib");

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CRemoveDebugFromLibDlg::OnOK()
{
CString		sText;
int			iRet;


	UpdateData();
	ComboBoxSave(this,IDC_COMBO1,"#NameList","Software\\AZ\\RemoveDebugFromLib");


	if(ExistFile(m_sLibPath)!=1)
		{
		MessageBox("Die Datei konnte nicht gefunden werden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	
	iRet = LibRemoveDebug(m_sLibPath,NULL);

	if(iRet==-1)
		{
		MessageBox("Die Datei konnte nicht geffnet werden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(iRet==-2)
		{
		MessageBox("Es wurden keine Debug-Informationen in der Bibliothek gefunden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(iRet)
		{
		sText.Format("Es gab einen Fehler beim Laden (%i) !",iRet);
		MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	MessageBox("Es wurde eine Bibliothek ohne Debug-Informationen erstellt.","Information",MB_OK|MB_ICONINFORMATION);


return;
}

